#include<bits/stdc++.h>
using namespace std;
int n,q,ss[300005],l,r,br;

void set1(){
    cout<<l-r<<endl;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>q;
    for(int i=1;i<=n;i++){
        cin>>ss[i];
        if(ss[i]=='?') br++;
    }
    for(int i=1;i<=q;i++){
        cin>>l>>r;
        if(br==n) set1();
    }
    return 0;
}